]>

# Manual do KMidi

Bernd Johannes
Wuebben

    wuebben@kde.org

Greg
Lee

    lee@hawaii.edu

17 Junho 1998
Versão 1.1

Este manual descreve o KMidi versão 1.1

KDE
KMidi
midi player

## Introdução

Kmidi é um reprodutor de arquivos MIDI e conversor do formato MIDI para o formato WAV.

Se você já desistiu do MIDI sob Linux/Unix, tente este programa ! Sem hardware de alto preço como as placas Gravis Ultrasound ou Sound Blaster AWE64, você conseguirá um som fantástico, comparável ao que você obteria com as placas mencionadas, DE GRAÇA !

O outro lado da moeda:

- KMidi usará bastante seu processador, tipicamente 10-30&percnt; numa freqüência de amostragem de 32000 Hz no Pentium 120 do autor. Se você tem uma máquina mais lenta, basta usar as opções de linha de comando para reduzir a freqüência de amostragem. Você deve ser capaz de obter um som bastante decente mesmo em um 486, sem sobrecarregar a máquina.

- Você precisa de arquivos complementares de som. Você pode conseguir um conjunto completo de arquivos de som para General MIDI em qualquer site-arquivo da Ultrasound. A necessidade de espaço em disco para esses arquivos gira em torno de 10 MB.

Acredite em mim, pelo som que você obterá, o preço é muito pequeno !

O KMidi suporta no momento (versão 1.1) as seguintes plataformas:

- Linux

- FreeBSD

- DEC OSF/1

- HP UX

- SUN

- SUN SOLARIS

A versão alternativa (não-KDE) do TiMidity também deve funcionar em todas essas plataformas, mas essa versão foi testada apenas no Linux.

Portar para outras plataformas deve ser fácil. Queira contactar-me se você portar o KMidi para outra plataforma.

O Kmidi usa o aplicativo TiMidity 0.2i, de Tuuka Toivonen, Copyright (C) 1995 Tukka Toivonen. Na verdade, é uma versão melhorada do programa original de Tuuka com cinco interfaces de usuário alternativas. (Veja mais abaixo para obter informações sobre como compilar o TiMidity.) KMidi e TiMidity usam as extensões AWE SoundFont escritas por Takashi Iwai e as extensões AMD InterWave escritas por Greg Lee, que lhe permitem usar as SoundFonts (arquivos .sbk/.sf2) e conjuntos de arquivos complementares IW (arquivos .fff/.dat) em adição aos arquivos .pat Gravis/Forte.

Para detalhes sobre o uso que podem não estar cobertos nesse manual, veja a pagina `man` para o `timidity(1)`.

Digo que esta é uma versão experimental do KMidi, ainda tem algumas arestas, e tenho certeza de que se você tentar bastante, conseguirá fazer o KMidi falhar; mesmo assim acredito que o KMidi ja' é operacional o suficiente e lhe dará horas e horas de divertimento. Lembre que arquivos MIDI sao tipicamente menores que 50k - fáceis e rápidos de serem obtidos via Internet - portanto nunca lhe faltarão bons MIDIs para tocar.

Divirta-se com o KMidi !

`Bernd Johannes Wuebben`, wuebben@kde.org

## Instalação

### Como obter o KMidi

KMidi é parte do projeto KDE http://www.kde.org. KMidi pode ser encontrado em ftp://ftp.kde.org/pub/kde/, o principal site FTP do projeto KDE. O site base do KMidi é http://math.cornell.edu/~wuebben/kde.html

### Pré-requisitos

Para compilar com sucesso o KMidi, você precisa das últimas versões de `libkdecore` e `libkdeui` . Todas as bibliotecas requeridas bem como o KMidi em si podem ser encontrados em ftp://ftp.kde.org/pub/kde/.

Para compilar a interface de linha de comando do TiMidity, qualquer sistema no estilo Unix deve servir, ou mesmo o Windows 95. As outras interfaces têm requisitos especiais (veja os vários arquivos README na distribuição). A interface Motif funciona razoavelmente bem com Lesstif.

### Compilação e instalação

Se você já tinha o KMidi instalado antes, seria interessante fazer uma cópia de segurança dos arquivos do diretório de configuração (geralmente `$KDEDIR/share/apps/kmidi/config/`) antes de instalar uma versão mais atual, visto que certos arquivos podem ser sobrescritos. Similarmente, antes de instalar a versão não-KDE do TiMidity, faça uma cópia de segurança de `/usr/local/lib/timidity/*`.

Por outro lado, para fazer uma instalação completamente nova, você deve remover quaisquer diretorios, pois os arquivos antigos podem não ser sobrepostos pelos novos.

Se você tem o pacote `kdemultimedia` inteiro, entre no diretório `kdemultimedia` e

    % ./configure

Então, para compilar todos os programas de multimídia, permaneça nesse diretório; ou para compilar apenas o KMidi, entre no diretório `kmidi` e

    % make
    % make install

Para a versão não-KDE do TiMidity, edite o arquivo Makefile.tim conforme requerido (dependendo de qual interface de usuario você quer), então

    % make clean
    % make -f Makefile.tim
    % make -f Makefile.tim install.bin
    % make -f Makefile.tim install.lib
    % make -f Makefile.tim install.man

Se você tiver problemas, queira reportá-los a mim.

### Onde eu consigo um conjunto completo de arquivos complementares ?

Há três tipos de arquivos que KMidi/TiMidity pode usar: GUS, IW e AWE32. Um conjunto de amostragens e parâmetros para um instrumento estará num arquivo isolado no caso do formato GUS, porém o formato IW traz varias amostragens dentro de um único arquivo `.dat`, e parâmetros de vários instrumentos em um único arquivo `.fff`. O formato AWE coloca tudo num único arquivo `.sf2` ou `.sbk`.

Alguns lugares onde você pode encontrar arquivos GUS:

Dan Hollis criou um conjunto de arquivos. Visite sua página em http://www.anime.net/~goemon/timidity e ajude-o a fazer deste o melhor conjunto disponível.

Novas: Eu copiei o conjunto acima para o site `ftp.kde.org`. Ele pode ser encontrado em `ftp://fiwi02.wiwi.uni-tuebingen.de/pub/kde/stable/Beta2/apps/multimedia/sound/` mas eu acredito que será movido desse diretório para outros até que encontremos um bom lugar para ele. Portanto, dê uma olhada geral no site `ftp.kde.org`, se você não puder encontrar o conjunto no local previamente mencionado.

Os conjuntos também podem ser encontrados empacotados como módulos `rpm` ou `deb` no arquivo SunSite:

- Debian: timidity-patches_0.1.tar.gz

- RPM: timidity-patches-1-1.i386.rpm

- RPM: timidity-patches-1-1.src.rpm-try2

Eu não tentei os sites acima (ainda), e pessoalmente uso o conjunto Midia com alguns arquivos adicionais e dois conjuntos de percussão.

O conjunto Midia pode ser encontrado em: ftp://archive.cs.umbc.edu/pub/midia/

Para conjuntos adicionais e conjuntos de percussão: (pegue os conjuntos `gsdrum` e `wow`) ftp://ftp.cdrom.com/pub/gus/sound/patches/files/

Vincent Pagel criou um conjunto de arquivos. Esse link só funcionará durante o horário noturno de Paris, o que significa madrugada e manhãzinha no Brasil: ftp://sig.enst.fr/pub/midi/instruments/

O arquivo de configuração que serve para esse conjunto pode ser encontrado aqui: ftp://sig.enst.fr/pub/midi/timidity_pagel.cfg

Veja a TimidityPage: http://www.clinet.fi/~toivonen/timidity/

e a Takashi's Page: http://bahamut.mm.t.u-tokyo.ac.jp/~iwai/midi.html#TiMidity

A página de Takashi recomenda o arquivo AWE32 SoundFont de 8MB `chaos8m.sf2` e o arquivo AWE32 SoundFont de 12MB `chaos12m.sf2` disponíveis em http://soback.kornet.nm.kr/~chaos/sbawe32/sbawe32.htm, que são muito bons. (Eles são empacotados como EXEs de auto-descompressão).

Há vários arquivos IW gratuitos em ftp://sdc.wtm.tudelft.nl/pub/music/soundbank/. O único conjunto IW que eu conheço com arquivos stereo (which KMidi/TiMidity can play) custa $33 em um CD; veja o site http://sdc.wtm.tudelft.nl/utopia/.

#### Instalação do conjunto de arquivos complementares

Cada um dos conjuntos de arquivos acima (você só precisa de um) deve vir com um arquivo de configuração `.cfg`, semelhante aos arquivos `.cfg` que vêm com o KMidi e residem em `KDEDIR/share/apps/kmidi/config`

O KMidi tem arquivos de configuração prontos para aceitar um certo número de conjuntos de arquivos complementares.

Para completar a instalação de um conjunto completo de arquivos complementares, edite o arquivo `timidity.cfg` e configure-o para aceitar os arquivos que você conseguiu. (Se você der uma olhada no arquivo `timidity.cfg`, ficará totalmente óbvio do que estou falando).

E é isso aí. Agora você pode seguir em frente e reproduzir os outros MIDIs que vêm com a distribuição do KMidi (e muitos outros, é claro).

#### Miscelânea

Ocasionalmente você verá que o KMidi não pôde encontrar um arquivo para determinado instrumento. (Abra a Janela Informações para checar isso). Nesse caso, o que você tem a fazer é achar por si mesmo o arquivo em falta e instalá-lo no diretório `patch`, e editar o arquivo `.cfg` do conjunto de arquivos complementares, para dizer ao KMidi que o novo patch está disponível agora.

Às vezes um instrumento em particular não soa lá muito bem. Nesse caso, basta conseguir um novo conjunto de arquivos complementares de qualquer um dos arquivos Ultrasound e trocar o arquivo ruim pelo melhor. Como você pode ver, só depende de você a qualidade de som dos instrumentos. Você pode até fazer seus próprios arquivos complementares, usando o utilitário `pat2wav` que está incluído na distribuição do KMidi.

## Uso

### Uso Geral

Simplesmente clique o botão "eject" para abrir o gerenciador de listas de reprodução. Selecione um arquivo MIDI clicando duas vezes sobre ele. Para sua conveniência, eu incluí alguns arquivos MIDI no diretorio `midis` da distribuição. Para uso real você terá de conseguir um conjuunto completo de arquivos complementares de som MIDI.

### Nomes de arquivos Midi

KMidi trocará qualquer '&lowbar;' (caractere sublinhado) no arquivo MIDI por espaços e retirar o final .mid ou .MID se existir.

### Opções de Linha de Comando

    wuebben: ./kmidi -h
     KMidi versão 0.3  MIDI para WAVE reprodutor/conversor
     Copyright (C) 1995 Bernd Johannes Wuebben <wuebben@math.cornell.edu>

     KMidi é software gratuito e vem sem ABSOLUTAMENTE NENHUMA GARANTIA.

    Uso:
      kmidi [opções] arquivo [...]

    Opções:
      -o arq  Saída para outro arquivo (ou dispositivo) (Use "-" para stdout)
      -O modo Selecionar modo de saída e formatação (veja lista abaixo)
      -s f    Mudar freqüência de amostragem para f (Hz ou kHz)
      -a      Habilitar o filtro de "antialiasing"
      -f      Desliga modo de decaimento rápido
      -p n    Permite polifonia a n vozes
      -A n    Amplificar volume em n % (pode causar clipagem)
      -C n    Muda taxa de amostragem e freqüências de controle

      -L dir  Adiciona dir ao caminho de procura
      -c arq  Ler arquivo de configuração extra
      -I n    Usar programa n como padrão
      -P arq  Usa arquivo complementar para todos os programas
      -D n    Reproduzir percussão no canal n
      -Q n    Ignorar canal n
      -F      Habilitar fast panning
      -U      Descarregar instrumentos da memória entre um MIDI e outro

      -i modo Selecionar interface de usuário (veja lista abaixo)
      -B n    Muda número de fragmentos de buffer para n
      -h      Mostra essa mensagem de ajuda

    Modos disponíveis de saída: (opção -O):

      -Od     Dispositivo dsp Linux
      -Ow     Arquivo RIFF WAVE (.wav)
      -Or     Forma de onda simples

    Opções de formato de saída (adicione à opção -O?):

       `8'    amostragem a 8 bits
       `1'    amostragem a 16 bits
       `U'    codificação uLaw
       `l'    codificação linear
       `M'    monofônico
       `S'    estéreo
       `s'    saída com sinal (positivo/negativo)
       `u'    saída sem sinal
       `x'    saída com byte trocado

    Interfaces disponíveis (opção -i):

      -iq     interface KMidi/Qt
      -id     interface terminal

    Opções de Interface (adicione à opção -i?):

       `v'    Mais mensagens (cumulativo)
       `q'    Menos mensagens (cumulativo)
       `t'    "trace playing"

## Perguntas e Respostas

### Onde conseguir todos os arquivos de som ?

Queira ir à seção correspondente no capítulo de instalação do KMidi.

## Copyright

    KMidi Copyright 1997 Bernd Johannes Wuebben <wuebben@math.cornell.edu>

    KMidi usa o programa TiMidity 0.2i de Tuukka Toivonen.
    Copyright (C) 1995 Tukka Toivonen <toivonen@clinet.fi>

    Arquivos complementares de som de
    Takashi Iwai <iwai@dragon.mm.t.u-tokyo.ac.jp>

    Este programa é software gratuito; voce pode redistribuí-lo e/ou
    modificá-lo sob os termos da Licença Pública Geral GNU conforme
    publicada pela Free Software Foundation; seja a versão 2 da Licença,
    ou (à sua escolha) qualquer versão posterior.

    Este programa é distribuído na esperança de que será útil,
    porem SEM QUALQUER GARANTIA; desprovido inclusive da garantia implícita
    de MERCANTIBILIDADE ou APLICABILIDADE PARA UM PROPÓSITO EM PARTICULAR.
    Veja a Licença Pública Geral para maiores detalhes.

    Você deve ter recebido uma cópia da Licença Pública Geral GNU
    junto com este programa; se não, escreva para Free Software Foundation,
    Inc., 675 Mass Ave, Cambridge, MA 02139, USA.